module Tiramisu
  class Expectation

    # ensure received message throws as expected
    #
    # @note if block given it will have precedence over arguments
    #
    # @example
    #   x = mock(X.new)
    #   expect(x).to_receive(:y).and_throw(:z)
    #
    def and_throw symbol = nil, &block
      @throw = [symbol, block]
    end

    def assert_message_thrown_as_expected
      return unless @throw
      received_messages.each do |log|
        next unless f = Tiramisu.assert_thrown_as_expected(log, *@throw)
        Tiramisu.fail(f, log[:caller])
      end
    end
  end
end
