module Tiramisu

  def assert_thrown_as_expected object, expected_symbol = nil, block = nil
    f = assert_thrown(object)
    return f if f

    return assert_thrown_as_expected_by_block(object, block) if block

    if expected_symbol
      f = assert_expected_symbol_thrown(object, expected_symbol)
      return f if f
    end
    nil
  end

  def assert_thrown_as_expected_by_block object, block
    return [
      'Looks like wrong or no symbol thrown at %s' % object[:caller],
      'See validating block'
    ] unless block.call(object[:thrown])
    nil
  end

  def assert_thrown object
    return [
      'Expected a symbol to be thrown at %s' % object[:caller]
    ] unless object[:thrown]
    nil
  end

  def assert_expected_symbol_thrown object, expected_symbol
    return begin
      [
        'Expected :%s to be thrown at %s' % [expected_symbol, object[:caller]],
        'Instead :%s thrown' % object[:thrown]
      ]
    end unless expected_symbol == object[:thrown]
    nil
  end
end
