module Tiramisu

  def refute_thrown_as_expected object, expected_symbol, block = nil
    f = refute_thrown(object, expected_symbol)
    return f if f

    if expected_symbol
      f = refute_expected_symbol_thrown(object, expected_symbol)
      return f if f
    end
    nil
  end

  def refute_thrown object, should_throw = false
    if should_throw
      return [
        'Expected a symbol to be thrown at %s' % object[:caller]
      ] unless object[:thrown]
    else
      return [
        'Not expected a symbol to be thrown at %s' % object[:caller]
      ] if object[:thrown]
    end
    nil
  end

  def refute_expected_symbol_thrown object, expected_symbol
    return [
      'Not expected :%s to be thrown' % expected_symbol,
      'at %s' % object[:caller]
    ] if expected_symbol == object[:thrown]
    nil
  end
end
